function pickedGenes = AddCntrlSeqs(pickedGenes,cntrl,numOligos,numCntrls,numBlanks,varargin)




parameters.distribute = true; % 

%% 
% pickedGenesOrig = pickedGenes;
% pickedGenes = pickedGenesOrig;

% cntrlFasta = [TSTORMlib,'BLASTedRandomSeqs.fasta'];
% numOligos = 198;
% numCntrls = 2; 
% cntrl = fastaread(cntrlFasta);

numGenes = length(pickedGenes.Sequence);
randSeqs = {cntrl.Sequence}';
randSeqs = randSeqs(randperm(length(randSeqs)));

if parameters.distribute
    insertPositions = round( (numGenes+numCntrls)/numCntrls*(1:numCntrls))-1;% -(numCntrls+1);

    % Add random sequences
    j = 1;
    for n=1:numCntrls % n=5
        i = insertPositions(n);
        pickedGenes.CommonName = cat(1,pickedGenes.CommonName(1:i),...
                                {['notarget',sprintf('%03d',n)]},...
                                pickedGenes.CommonName(i+1:end) );
        pickedGenes.Sequence  =  cat(1,pickedGenes.Sequence(1:i),...
                                        {randSeqs(j:j+2*numOligos-1)'},...
                                        pickedGenes.Sequence(i+1:end) );
        pickedGenes.FivePrimeEnd =  cat(1,pickedGenes.FivePrimeEnd(1:i),...
                                            {40*(j:j+2*numOligos-1)},...
                                        pickedGenes.FivePrimeEnd(i+1:end) );
        pickedGenes.IsoformName =  cat(1,pickedGenes.IsoformName(1:i),...
                                            {''},...
                                        pickedGenes.IsoformName(i+1:end) );
        pickedGenes.GeneName =  cat(1,pickedGenes.GeneName(1:i),...
                                             {''},...   
                                        pickedGenes.GeneName(i+1:end) );
        pickedGenes.Nprobes =  cat(1,pickedGenes.Nprobes(1:i),...
                                               {(2*numOligos)},... 
                                        pickedGenes.Nprobes(i+1:end) );
        pickedGenes.FPKM =  cat(1,pickedGenes.FPKM(1:i),...
                                                0,... 
                                        pickedGenes.FPKM(i+1:end) );
        pickedGenes.MeltingTemp = cat(1,pickedGenes.MeltingTemp(1:i),... 
                                            {[]},...
                                        pickedGenes.MeltingTemp(i+1:end) );
        pickedGenes.FreeEnergy =  cat(1,pickedGenes.FreeEnergy(1:i),...
                                            {[]},...
                                        pickedGenes.FreeEnergy(i+1:end) );
        pickedGenes.Enthalpy =  cat(1,pickedGenes.Enthalpy(1:i),...
                                            {[]},...
                                        pickedGenes.Enthalpy(i+1:end) );
        pickedGenes.Entropy =  cat(1,pickedGenes.Entropy(1:i),...
                                            {[]},...
                                        pickedGenes.Entropy(i+1:end) );
        pickedGenes.GeneNumber =  cat(1,pickedGenes.GeneNumber(1:i),...
                                            {[]},...
                                        pickedGenes.GeneNumber(i+1:end) );
        pickedGenes.Locus =  cat(1,pickedGenes.Locus(1:i),...
                                            {''},...
                                        pickedGenes.Locus(i+1:end) );
        j = j+2*numOligos-1;
    end


    % Add blank sequences

    numGenes = length(pickedGenes.Sequence);
    insertPositions = round( (numGenes+numBlanks)/numBlanks*(1:numBlanks))-1;

    for n=1:numBlanks % n=5
        i = insertPositions(n);
        pickedGenes.CommonName = cat(1,pickedGenes.CommonName(1:i),...
                                {['blank',sprintf('%03d',n)]},...
                                pickedGenes.CommonName(i+1:end) );
        pickedGenes.Sequence  =  cat(1,pickedGenes.Sequence(1:i),...
                                        {''},...
                                        pickedGenes.Sequence(i+1:end) );
        pickedGenes.FivePrimeEnd =  cat(1,pickedGenes.FivePrimeEnd(1:i),...
                                            {j},...
                                        pickedGenes.FivePrimeEnd(i+1:end) );
        pickedGenes.IsoformName =  cat(1,pickedGenes.IsoformName(1:i),...
                                            {''},...
                                        pickedGenes.IsoformName(i+1:end) );
        pickedGenes.GeneName =  cat(1,pickedGenes.GeneName(1:i),...
                                             {''},...   
                                        pickedGenes.GeneName(i+1:end) );
        pickedGenes.Nprobes =  cat(1,pickedGenes.Nprobes(1:i),...
                                               {0},... 
                                        pickedGenes.Nprobes(i+1:end) );
        pickedGenes.FPKM =  cat(1,pickedGenes.FPKM(1:i),...
                                                0,... 
                                        pickedGenes.FPKM(i+1:end) );
        pickedGenes.MeltingTemp = cat(1,pickedGenes.MeltingTemp(1:i),... 
                                            {[]},...
                                        pickedGenes.MeltingTemp(i+1:end) );
        pickedGenes.FreeEnergy =  cat(1,pickedGenes.FreeEnergy(1:i),...
                                            {[]},...
                                        pickedGenes.FreeEnergy(i+1:end) );
        pickedGenes.Enthalpy =  cat(1,pickedGenes.Enthalpy(1:i),...
                                            {[]},...
                                        pickedGenes.Enthalpy(i+1:end) );
        pickedGenes.Entropy =  cat(1,pickedGenes.Entropy(1:i),...
                                            {[]},...
                                        pickedGenes.Entropy(i+1:end) );
        pickedGenes.GeneNumber =  cat(1,pickedGenes.GeneNumber(1:i),...
                                            {[]},...
                                        pickedGenes.GeneNumber(i+1:end) );
        pickedGenes.Locus =  cat(1,pickedGenes.Locus(1:i),...
                                            {''},...
                                        pickedGenes.Locus(i+1:end) );
        j = j+2*numOligos-1;
    end

else  % Add at the end

    % Add random sequences
    j = 1;
    for n= numGenes + 1 : numGenes + numCntrls
        pickedGenes.CommonName{n,1} = ['notarget',sprintf('%03d',n)];
        pickedGenes.Sequence{n,1}  =  randSeqs(j:j+2*numOligos-1)';
        pickedGenes.FivePrimeEnd{n,1} = 40*(j:j+2*numOligos-1);
        pickedGenes.IsoformName{n,1} = '';
        pickedGenes.GeneName{n,1} = '';    
        pickedGenes.Nprobes{n,1} = (2*numOligos); 
        pickedGenes.FPKM(n,1) = 0; 
        pickedGenes.MeltingTemp{n,1} = {};
        pickedGenes.FreeEnergy{n,1} = {};
        pickedGenes.Enthalpy{n,1} = {};
        pickedGenes.Entropy{n,1} = {};
        pickedGenes.GeneNumber{n,1} = {};
        pickedGenes.Locus{n,1} = '';
        j = j+2*numOligos-1;
    end

    % Add blanks
    for n= numGenes + numCntrls + 1 : numGenes + numCntrls + numBlanks
        pickedGenes.CommonName{n,1} = ['blank',sprintf('%03d',n)];
        pickedGenes.Sequence{n,1}  =  {};
        pickedGenes.FivePrimeEnd{n,1} = j;
        pickedGenes.IsoformName{n,1} = '';
        pickedGenes.GeneName{n,1} = '';    
        pickedGenes.Nprobes{n,1} = (2*numOligos); 
        pickedGenes.FPKM(n,1) = 0; 
        pickedGenes.MeltingTemp{n,1} = {};
        pickedGenes.FreeEnergy{n,1} = {};
        pickedGenes.Enthalpy{n,1} = {};
        pickedGenes.Entropy{n,1} = {};
        pickedGenes.GeneNumber{n,1} = {};
        pickedGenes.Locus{n,1} = '';
        j = j+2*numOligos-1;
    end

end